﻿using Newtonsoft.Json;

class FolderCrawler : Crawler{

    public FolderCrawler(ConfigYaml c, Source s) : base(c, s){}

    public override void getLoadeableSources() {

        string[] dirs;

        if (s.public_folder != null) {
            dirs = Directory.GetDirectories(this.s.path, s.public_folder, SearchOption.TopDirectoryOnly);
        }
        else {
            dirs = Directory.GetDirectories(this.s.path, "*", SearchOption.TopDirectoryOnly);
        }
            
        for (int i = 0; i < dirs.Length; i++) {
                
            string options_file = dirs[i] + Path.DirectorySeparatorChar + c.options_file;

            if (File.Exists(options_file)){                    
                int new_i = i;
                string folder_to_load = dirs[i];

                var task = Task.Run(() => {
                    Folder f = new Folder(options_file, folder_to_load);
                });

                task.ContinueWith(t => {
                    Console.WriteLine(t.Exception);
                }, TaskContinuationOptions.OnlyOnFaulted);

            }
        }
    }
}